//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "mainfrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SDL_rchart"
#pragma link "SDL_vector"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BButLoadDataClick(TObject *Sender)
{
PageControl1->ActivePage = TSData;
ODiag1->FileName = "*.asc";
if (ODiag1->Execute())
  {
  TabEdData->Data->ImportASC (ODiag1->FileName);
  }
}
//---------------------------------------------------------------------------
TColor __fastcall TForm1::MapColors(int index)
{
const TColor DefColors[] = {clBlack, clBlue, clRed, clGreen,
                            clBlack, clBlue, clRed, clGreen,
                            clBlack, clBlue, clRed, clGreen,
                            clBlack, clBlue, clRed, clGreen};

if (index < 0)
  {
  index = 0;
  }
index = index-16*(index/16);
return DefColors[index];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BButPerformPCAClick(TObject *Sender)
{
const FIRSTPC = 1;
const SECONDPC = 2;

int     i;
double  m, s;
double  x, y;
int     obj;

if (PageControl1->ActivePage == TSData)
  {
  PageControl1->ActivePage = TSScores;
  }
if (! CalcPrincComp(TabEdData->Data->NumericData, 1, TabEdData->Data->NrOfColumns, 1, TabEdData->Data->NrOfRows, RGScaling->ItemIndex))
  {
  MessageDlg ("Cannot calculate principal components", mtInformation, TMsgDlgButtons() << mbOK, 0);
  }
else
  {
  Mean->NrOfElem = TabEdData->NrOfColumns;
  StdDev->NrOfElem = TabEdData->NrOfColumns;  // calc. mean and standard deviation for correct score plot
  switch (RGScaling->ItemIndex)
    {
    case 0 : {        // scatter matrix
			 for (i=1; i<=TabEdData->NrOfColumns; i++)
			   {
			   Mean->Elem[i] = 0;
			   StdDev->Elem[i] = 1;
			   };
			 break;
			 };
	case 1 : {       // covariance matrix
			 for (i=1; i<=TabEdData->NrOfColumns; i++)
			   {
			   TabEdData->Data->NumericData->MeanVar (i,1,i,TabEdData->NrOfRows,m,s);
			   Mean->Elem[i] = m;
			   StdDev->Elem[i] = 1;
			   };
			 break;
			 };
	case 2 : {       // correlation matrix
             for (i=1; i<=TabEdData->NrOfColumns; i++)
               {
               TabEdData->Data->NumericData->MeanVar (i,1,i,TabEdData->NrOfRows,m,s);
               Mean->Elem[i] = m;
               StdDev->Elem[i] = sqrt(s);
               };
             break;
             };
    };

      // display scores
  RCScores->ClearGraf();
  RCScores->Scale1X->Caption = "PC "+IntToStr(FIRSTPC);
  RCScores->Scale1Y->Caption = "PC "+IntToStr(SECONDPC);
  RCScores->Caption = "Score/Score Plot - " + RGScaling->Items->Strings[RGScaling->ItemIndex];
  for (obj=1; obj<=TabEdData->NrOfRows; obj++)
	{
	x = 0;
	for (i=1; i<=TabEdData->NrOfColumns; i++)
	  {
	  s = StdDev->Elem[i];
	  if (s != 0.0)
		{
		x = x + GetEigenResult (FIRSTPC,i) * (TabEdData->Elem[i][obj]-Mean->Elem[i])/s;
        }
      };
    y = 0;
    for (i=1; i<=TabEdData->NrOfColumns; i++)
      {
      s = StdDev->Elem[i];
      if (s != 0.0)
        {
        y = y + GetEigenResult (SECONDPC,i) * (TabEdData->Elem[i][obj]-Mean->Elem[i])/s;
        }
      };
    RCScores->DataColor = MapColors(TabEdData->RowAttrib[obj]);
    RCScores->MarkAt (x,y,6);
    };
  RCScores->AutoRange(1,3);
  RCScores->ShowGraf();

         // display loadings
  RCLoadings->ClearGraf();
  RCLoadings->Scale1X->Caption = "PC "+strff(FIRSTPC,1,0);
  RCLoadings->Scale1Y->Caption = "PC "+strff(SECONDPC,1,0);
  RCLoadings->Caption = "Loading/Loading Plot - "+RGScaling->Items->Strings[RGScaling->ItemIndex];
  RCLoadings->DataColor = clGray;
  RCLoadings->Line (-1,0,1,0);
  RCLoadings->Line (0,-1,0,1);
  RCLoadings->DataColor = clNavy;
  RCLoadings->MoveTo (GetEigenResult (FIRSTPC,1),
                  GetEigenResult (SECONDPC,1));
  for (i=1; i<=TabEdData->NrOfColumns; i++)
    {
    RCLoadings->DataTag = 0;
    RCLoadings->Text (GetEigenResult (FIRSTPC,i), GetEigenResult (SECONDPC,i),8, IntToStr(i));
    };
  RCLoadings->AutoRange(1, 3);
  RCLoadings->ShowGraf();
  };
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BButNewDataClick(TObject *Sender)
{
int i, j;

TabEdData->SuppressPaint = true;
TabEdData->NrOfColumns = 5;
TabEdData->NrOfRows = 150;
for (j=1; j<=TabEdData->NrOfRows; j++)
  {
  for (i=1; i<=TabEdData->NrOfColumns; i++)
    {
	TabEdData->Elem[i][j] = 0.000001*random(1000)*random(1000) + (j % 3)*(i % 2);
    TabEdData->Elem[i][j] = TabEdData->Elem[i][j] + 3*TabEdData->Elem[i-1][j]+0.0001*random(1000);
    }
  TabEdData->RowAttrib[j] = 1 + j % 3;
  }
TabEdData->SuppressPaint = false;
}
//---------------------------------------------------------------------------

